# Documentation

This directory contains everything to do with the documentation for the
project. It's based on a mashup of Sphinx and Doxygen, intended to be built by
ReadTheDocs. You can also try building it manually if you're on Linux (probably
won't work elsewhere, your mileage may vary) assuming you have sphinx, doxygen,
graphviz, and everything normally needed to build the project.

File/directory list:

 - `rebuild.sh`: delete the cached output directories and build locally.

 - `Makefile`, `make.bat`: generated by Sphinx, used to build the
   documentation. You can build with `make html`, but the results are cached
   without checking if the sources have changed, so you need to remove the
   output directories (`doxygen`, `build`) manually to *re*build.

 - `Doxyfile`, `DoxygenLayout.xml`: Doxygen configuration. Note that the Sphinx
   build will chain to Doxygen and include it in its output.

 - `main-page.dox`: main page and misc directives that don't fit elsewhere for
   the Doxygen documentation.

 - `requirements.txt`: build requirements file (Python packages) used by
   ReadTheDocs.

 - `source`: source files for the Sphinx part of the documentation.

Generated:

 - `doxygen`: build output directory for Doxygen.

 - `build`: build output directory for Sphinx.
